/*   
    
    chess-Ec       Copyright (C)   2001-2008 Marc Dechico


    ec_ctle.h : all function to check or recheck if chess.
    
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/

#include "ec_global.h"
/******************************************************/
/* external data */
/******************************************************/

/* tableau pointant sur piece camp 0 ou 1 */
/* poste 0 camp 0, 1 camp 1 */
extern struct st_pie *tpts_pie[2];		

/* tableau touver ID piece roi camp [0/1] */
extern int Id_roi[2];

/* tableau pour trouver position du roi a partir du camp */
extern int *pts_pie_pos_Roi[2];

/* tableau echiquier acces par l'emplacement  */
extern struct st_ech ts_ech[100];
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro; 	
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro_p; 
/* ptr sur tbl structure piece principale*/
extern struct st_pie  		*pts_pie;  
    	
/*  pour detection echec ec_ctl.c */
/*extern const int ti_ech_dir_rei[100][100];*/
extern  def_ti_ech_dir_rei  ti_ech_dir_rei;
extern  def_ti_ech_dir_fou  ti_ech_dir_fou;
extern  def_ti_ech_dir_tou  ti_ech_dir_tou;
extern  def_ti_ech_dir_cav  ti_ech_dir_cav;
extern  def_ti_ech_dir_roi  ti_ech_dir_roi;
extern  def_ti_ech_dir_rei  ti_ech_dir_pio_noi;
extern  def_ti_ech_dir_rei  ti_ech_dir_pio_bla;
extern  def_ti_ech_dir_rei  ti_ech_dir_inc;

/******************************************************/
/* local function */
/******************************************************/


/* controle si la piece  mouvementee cause un echec*/
int ech_par_rei     (int n, int nr);
int ech_par_fou     (int n, int nr);
int ech_par_tou     (int n, int nr);
int ech_par_cav     (int n, int nr);
int ech_par_roi     (int n, int nr);
int ech_par_pio_0   (int n, int nr);
int ech_par_pio_1   (int n, int nr);

/* controle si une case est controlee par une piece*/
int ctl_par_rei     (int n, int nr);
int ctl_par_fou     (int n, int nr);
int ctl_par_tou     (int n, int nr);
int ctl_par_cav     (int n, int nr);
int ctl_par_roi     (int n, int nr);
int ctl_par_pio_0   (int n, int nr);
int ctl_par_pio_1   (int n, int nr);

int ctl_par_xxx(int nn);

/* echec: calcul direction demasquage */
//static void ech_cal_dir_dem  (int i_cam_roi,int *pi_ech_dir_dem);
void ech_cal_dir_dem_ca  (void);
void ech_cal_dir_dem_pc  (void);


/* adaptation pour traitement prise en passant */
int  ech_cal_dir_dem_2  (int i_cam_roi,int i_pos_n);

/* fct pour controle roi propre camp  echec     */
/* oblique: fou et reine */
 int cas_ctl_nul     (int n,int i_cam_adv);
 int cas_ctl_h_d     (int n,int i_cam_adv);
 int cas_ctl_h_g     (int n,int i_cam_adv);
 int cas_ctl_b_d     (int n,int i_cam_adv);
 int cas_ctl_b_g     (int n,int i_cam_adv);

/* droite  tour et reine */
 int cas_ctl_h     (int n,int i_cam_adv);
 int cas_ctl_b     (int n,int i_cam_adv);
 int cas_ctl_d     (int n,int i_cam_adv);
 int cas_ctl_g     (int n,int i_cam_adv);

/* cavalier */
 int cas_ctl_cav_h_d     (int n,int i_cam_adv);
 int cas_ctl_cav_d_h     (int n,int i_cam_adv);
 int cas_ctl_cav_d_b     (int n,int i_cam_adv);
 int cas_ctl_cav_b_d     (int n,int i_cam_adv);
 int cas_ctl_cav_b_g     (int n,int i_cam_adv);
 int cas_ctl_cav_g_b     (int n,int i_cam_adv);
 int cas_ctl_cav_g_h     (int n,int i_cam_adv);
 int cas_ctl_cav_h_g     (int n,int i_cam_adv);

/* pion */
 int cas_ctl_pio_g     	(int n,int i_cam_adv);
 int cas_ctl_pio_d     	(int n,int i_cam_adv);

