/*   
     
Chess-Ec    Copyright (C)   2001-2008 Marc Dechico


      ec_eva.h :  compute the datas collected during the simulation 
                (exploration of the game tree) 
		automat to find bugs in the engine (play random)
		automat to compare methode of evaluation 
  
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 37 98 22 54
 Mail: ec@chess-ec.org  
    
*/


#include "ec_global.h"
/************************************************************************/ 
/* external datas */
/************************************************************************/
/* tableau pointant sur pièce camp 0 ou 1 */
/* poste 0 camp 0, 1 camp 1 */
extern struct st_pie *tpts_pie[2];	
/* tableau echiquier accès par l'emplacement  */
extern struct st_ech ts_ech[100];              
/* tableau historique des coups */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];  
/* =1 si affichage note possible */
extern defv_bool defv_aff_not_pos;                  
/* = 1 si affichage calcul en cour */
extern defv_bool defv_aff_cal_cou;		
/* profondeur actuelle	*/        
extern int i_pro_act;                           
/* niveau de simulation */
extern int i_pro_sim_niv;			
/* nivde simu pour increment*/
extern int i_pro_sim_inc;			
/* profondeur de simulation 		*/
extern int i_pro_sim_act;             	
/* profondeur maximale superieur 	*/	
extern volatile int i_pro_sim_max_sup;         	
/* profondeur maximale inferieur	*/
extern volatile int i_pro_sim_max_inf;         		
/* note: compteur mvt initial 		*/
extern int i_not_cpt_mvt_ini;	
// the number of movments used in ts_not_mvt_ini
extern int i_not_cpt_mvt_ini_prt;
		
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro; 	
/* ptr sur tableau structure historique  */
extern struct st_hst_pro	*pts_hst_pro_p; 
/* ptr sur tbl structure pièce principale*/
extern struct st_pie  		*pts_pie;      	

/* branche */
#ifdef UPLOAD_BRANCHE   
extern int bra_prt_lst(struct st_bra_nod *pst_bra_nod_lst);
#endif

extern const int ti_typ_mvt_pri[NBR_TYP_MVT];
volatile defv_bool defv_bool_sigint; 

/************************************************************************/
/* external function */
/************************************************************************/
/* simu */
/* retourne meilleur mouvement */
extern int  simul(int i_pro_sim_niv_wrk,	       
		  int i_pro_sim_inc_wrk,
		  defv_bool defv_bool_use_hash,
		  defv_bool defv_bool_use_alpha_beta,
		  defv_bool defv_bool_ini_mvt_ini,
		  defv_bool defv_bool_ini_rap_for,
		  def_pf_not_cal pf_not_cal,
		  int i_cam_adv );
/* simulation pour evaluation meilleur mvt */
int  simul_eva       (int i_pro_sim_niv_wrk,	        
		      int i_pro_sim_inc_wrk);

extern void aff_cal_en_cou  (int i_not_cpt_mvt_ini,int i_aff_typ);
extern void aff_mes_uti     (int i_mes_num);
/* Stop simulation  */
extern void sto_sim 	    (void);	
/* ec_ini */
extern void 	ini_pgm      (void);
/* compute elapsed time  in millisecond */ 
extern long diff_time_ms ( struct timeval a2,  struct timeval a1);

/* ec_jou*/
/* joue avec coordonnes reelles */
extern  int jou	           (int i_pos_dep_n,  		 
		            int i_pos_arr_n,
		            char c_rem_pio	);
 /* simulation pour controle mat/pat */
extern  int simul_ctl       (void);			        
	/* annule coup */
extern void ann_cou 	    (void);		
extern int  sav_dsk         (char tc_nom_fic[40]);
/* traduit type mvt en type  piece*/
extern char pro_pio_tra_tmvt_tpie (int i_typ_mvt);    
/* traduit type mvt en type  piece*/ 
extern char pro_pio_tra_tmvt_lpie (int i_typ_mvt);    

extern int sim_add_l3(struct st_hash *pst_hash);
extern int sim_add_l2(struct st_hash *pst_hash);
extern int sim_add_l1(struct st_hash *pst_hash);
/* Choix profondeur et incrément de simulation */
extern  int cho_niv (int i_niv, int i_inc);
extern int  aff_not_1     (struct st_evaluation *st_eva);
extern int  aff_not_2     (struct st_evaluation *st_eva);

/************************************************************************/
/* inernal datas */
/************************************************************************/


/* Sous Structure  not_mvt_ini pour evaluation mat/pat par profondeur */
struct  st_hst_pro_sta tst_pro_sta[MVT_INI][PRO_SIM_INF_MAX]; 
//def_tst_pro_sta tst_pro_sta;

/* tableau note du mvt initial */
ST_NOT_MVT_INI  ts_not_mvt_ini[MVT_INI] ;

/* indexe pour retrier les mouvement */
struct st_tri_mvt_ini  ts_tri_mvt_ini [MVT_INI];
/* structure pour evaluation rapport de force */
struct st_eva_sit  st_eva_sit ;
static struct st_pos tst_pos [PRO_HST];


static int i_ran_cho=RANDOM_CHOICE;

/* Numero d'evaluation  */
int i_ver_eva;	
/* pointeur sur fonction évaluation */
//int (*pf_eva) (void);  	
struct st_ver tst_ver [VER_NBR];


/*    */
		
/********************************************************************/
/* Mark (note) each  position of pieces depending on situation      */
/********************************************************************/

tdef_not_pos  tdef_not_pos_pawn_open =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0,
  0,/*02*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*02*/0,
  0,/*03*/  0 , 0 , 0 ,00 ,00 , 0 , 0 , 0 , /*03*/0,
  0,/*04*/  0 , 0 , 0 ,90 ,90 , 0 , 0 , 0 , /*04*/0,
  0,/*05*/  0 , 0 , 0 ,90 ,90 , 0 , 0 , 0 , /*05*/0,
  0,/*06*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*06*/0,
  0,/*07*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*07*/0,
  0,/*08*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};
tdef_not_pos  tdef_not_pos_pawn_def =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0,
  0,/*02*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*02*/0,
  0,/*03*/ 30 ,40 ,50 ,50 ,50 ,50 ,40 ,30 , /*03*/0,
  0,/*04*/ 40 ,50 ,60 ,60 ,60 ,60 ,50 ,40 , /*04*/0,
  0,/*05*/ 50 ,60 ,70 ,70 ,70 ,70 ,60 ,50 , /*05*/0,
  0,/*06*/ 60 ,70 ,80 ,80 ,80 ,80 ,70 ,60 , /*06*/0,
  0,/*07*/ 70 ,80 ,90 ,90 ,90 ,90 ,80 ,70 , /*07*/0,
  0,/*08*/ 90 ,90 ,99 ,99 ,99 ,99 ,90 ,90 , /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};

tdef_not_pos  tdef_not_pos_knight_open =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*01*/0,
  0,/*02*/ -10, 50, 50, 50, 50, 50, 50,-10, /*02*/0,
  0,/*03*/   0, 50, 90, 90, 90, 90, 50,  0, /*03*/0,
  0,/*04*/ -10, 10, 20, 20, 20, 20, 10,-10, /*04*/0,
  0,/*05*/ -10, 0 , 0 , 10, 10, 0 , 0 ,-10, /*05*/0,
  0,/*06*/ -10, 0 , 0 , 0 , 0 , 0 , 0 ,-10, /*06*/0,
  0,/*07*/ -10, 0 , 0 , 0 , 0 , 0 , 0 ,-10, /*07*/0,
  0,/*08*/ -20,-10,-10,-10,-10,-10,-10,-20, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};
tdef_not_pos  tdef_not_pos_knight_def =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/ -20, 10, 10, 10, 10, 10, 10,-20, /*01*/0,
  0,/*02*/ -10, 50, 50, 50, 50, 50, 50,-10, /*02*/0,
  0,/*03*/   0, 50, 70, 70, 70, 70, 50,  0, /*03*/0,
  0,/*04*/ -10, 50, 70, 90, 90, 70, 50,-10, /*04*/0,
  0,/*05*/ -10, 50, 70, 90, 90, 70, 50,-10, /*05*/0,
  0,/*06*/ -10, 50, 70, 70, 70, 70, 50,-10, /*06*/0,
  0,/*07*/ -10, 50, 50, 50, 50, 50, 50,-10, /*07*/0,
  0,/*08*/ -20,-10,-10,-10,-10,-10,-10,-20, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0 

};

tdef_not_pos  tdef_not_pos_queen_open =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/ -99,-99,-99, 99, 99,-99,-99,-99, /*01*/0,
  0,/*02*/ -99,-99,-99,-99,-99,-99,-99,-99, /*02*/0,
  0,/*03*/ -99,-99,-99,-99,-99,-99,-99,-99, /*03*/0,
  0,/*04*/ -99,-99,-99,-99,-99,-99,-99,-99, /*04*/0,
  0,/*05*/ -99,-99,-99,-99,-99,-99,-99,-99, /*05*/0,
  0,/*06*/ -99,-99,-99,-99, 99,-99,-99,-99, /*06*/0,
  0,/*07*/ -99,-99,-99,-99, 99,-99,-99,-99, /*07*/0,
  0,/*08*/ -99,-99,-99,-99, 99,-99,-99,-99, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0, /*01*/0
};
tdef_not_pos  tdef_not_pos_queen_def =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/ -40, 0 , 0 , 0 , 0 , 0 , 0 ,-40, /*01*/0,
  0,/*02*/ -20, 20, 30, 30, 30, 30, 20,-20, /*02*/0,
  0,/*03*/ -20, 0 , 30, 30, 30, 30, 0 ,-20, /*03*/0,
  0,/*04*/ -20, 0 , 0 , 30, 30, 0 , 0 ,-20, /*04*/0,
  0,/*05*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*05*/0,
  0,/*06*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*06*/0,
  0,/*07*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*07*/0,
  0,/*08*/ -40,-20,-20,-20,-20,-20,-20,-40, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};
tdef_not_pos  tdef_not_pos_open =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0,
  0,/*02*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*02*/0,
  0,/*03*/ -20, 0 , 10, 10, 10, 10, 0 ,-20, /*03*/0,
  0,/*04*/ -20, 0 , 10, 20, 20, 10, 0 ,-20, /*04*/0,
  0,/*05*/ -20, 0 , 0 , 10, 10, 0 , 0 ,-20, /*05*/0,
  0,/*06*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*06*/0,
  0,/*07*/ -20, 0 , 0 , 0 , 0 , 0 , 0 ,-20, /*07*/0,
  0,/*08*/ -40,-20,-20,-20,-20,-20,-20,-40, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};
tdef_not_pos  tdef_not_pos_def  =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/ -40, 10, 10, 10, 10, 10, 10,-40, /*01*/0,
  0,/*02*/ -20, 10, 20,20 , 20, 20, 10,-20, /*02*/0,
  0,/*03*/ -20, 10, 20,90 , 90, 20, 10,-20, /*03*/0,
  0,/*04*/ -20, 10, 20,90 , 90, 20, 10,-20, /*04*/0,
  0,/*05*/ -20, 10, 20,90 , 90, 20, 10,-20, /*05*/0,
  0,/*06*/ -20, 10, 20,90 , 90, 20, 10,-20, /*06*/0,
  0,/*07*/ -20, 10, 20,20 , 20, 20, 10,-20, /*07*/0,
  0,/*08*/ -40,-20,-20,-20,-20,-20,-20,-40, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};
tdef_not_pos  tdef_not_pos_rook_def  =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0,
  0,/*02*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*02*/0,
  0,/*03*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*03*/0,
  0,/*04*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*04*/0,
  0,/*05*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*05*/0,
  0,/*06*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*06*/0,
  0,/*07*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*07*/0,
  0,/*08*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};
tdef_not_pos  tdef_not_pos_king_def  =
{
  0,/*xx*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*00*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*01*/ -10,  0, 0 , 0 , 0 , 0 , 0 ,-10, /*01*/0,
  0,/*02*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*02*/0,
  0,/*03*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*03*/0,
  0,/*04*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*04*/0,
  0,/*05*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*05*/0,
  0,/*06*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*06*/0,
  0,/*07*/  0 ,  0, 0 , 0 , 0 , 0 , 0 , 0 , /*07*/0,
  0,/*08*/ -10,  0, 0 , 0 , 0 , 0 , 0 ,-10, /*08*/0,
  /*      | A | B | C | D | E | F | G | H |       */
  0,/*00*/  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , /*01*/0

};

tptdef_not_pos tptdef_not_pos_pawn =
{
  /* opn_gam */   tdef_not_pos_pawn_open,
  /* mid_gam */   tdef_not_pos_pawn_def,
  /* end_gam */   tdef_not_pos_pawn_def
};

tptdef_not_pos tptdef_not_pos_knight =
{
  /* opn_gam */   tdef_not_pos_knight_open,
  /* mid_gam */   tdef_not_pos_knight_def,
  /* end_gam */   tdef_not_pos_knight_def
};
tptdef_not_pos tptdef_not_pos_bishop =
{
  /* opn_gam */   tdef_not_pos_open,
  /* mid_gam */   tdef_not_pos_def,
  /* end_gam */   tdef_not_pos_def
};
tptdef_not_pos tptdef_not_pos_rook =
{
  /* opn_gam */   tdef_not_pos_rook_def,
  /* mid_gam */   tdef_not_pos_rook_def,
  /* end_gam */   tdef_not_pos_rook_def
};
tptdef_not_pos tptdef_not_pos_queen =
{
  /* opn_gam */   tdef_not_pos_queen_open,
  /* mid_gam */   tdef_not_pos_queen_def,
  /* end_gam */   tdef_not_pos_queen_def
};
tptdef_not_pos tptdef_not_pos_king =
{
  /* opn_gam */   tdef_not_pos_king_def,
  /* mid_gam */   tdef_not_pos_king_def,
  /* end_gam */   tdef_not_pos_king_def
};


/*******************************************************************************/
/* local functions  */
/*******************************************************************************/
/* simul et joue  */
int sim_jou(void);                           
/* simul et joue with preSelection */
int sim_jou_sel(void);                           
/* simulation pour evaluation meilleur mvt */   
int  simul_eva_sel(int i_pro_sim_niv_wrk,	   
		   int i_pro_sim_inc_wrk);
/* init du trait */
static void ini_pos (int i_pro);		      
 /* sauvegarde du trait piece d'un camp */ 
static void sav_pos_pie (int i_pro, int i_cam);	      
 /* sauvegarde du trait */
void sav_pos (int i_pro);			     
  /* controle si trait se reproduit */		 
int ctl_rep_pos (int i_pro);		             
/* controle complet toutes pieces */ 
static int  ctl_rep_pos_pie (int i_pro_act, int i_pro);

int find_positive_sure_not(ST_NOT_MVT_INI *pts_mvt_ini,int i_not_cpt_mvt_ini);

/* retourne meilleur mouvement */
int eva_mei_mvt	   (void);	        
int eva_mei_mvt_00 (void);		      
int eva_mei_mvt_01 (void);		      
int eva_mei_mvt_02 (void);    
int eva_mei_mvt_beg_01 (void);   
int eva_mei_mvt_beg_02 (void); 
int eva_mei_mvt_int_01(void);   
int eva_mei_mvt_hig_01 (void); 

struct st_ver * get_ver_dta(int i_num_ver); 


 void 	not_mvt_ini_raz	(int i_pro_sim,		/* raz de la structure note mvt ini  avant simulation */
			 int i_inc_pro_sim);			
void	hst_cpt_raz (defv_bool defv_bool_hash,  /* init nbre de coup par niveaux */
		     int i_cam_ene);
int ver_ini (void);                             /* load version table (game difficulty)*/

/* calcule et mémorisation de la note du mvt initial */
void 	not_cal (void);			        
/* idem mais sans les statistiques (recalculation plus profonde) */
void 	not_cal_deep (void);		
/* traitement des données */
void tra_don (void); 
/* calcul couverture */
static  void cal_cou_rep (ST_NOT_MVT_INI *pts_mvt);

/* analyse de la couverture */
float  eva_cou_cam (int nn);		               
/* analyse de la couverture par piece*/
static float eva_cou_pie 	(int nn,int i_cam);
/* calcul mobilite */
static void cal_mob     ( ST_NOT_MVT_INI *pts_mvt);
/* calcul note position de la piece sur echiquier */
static void cal_pos     (
			 ST_NOT_MVT_INI *pts_mvt,          
			 enum e_sit_typ_not_pos e_sit_typ);
/* calcul note cost */
static void cal_cost     (
			 ST_NOT_MVT_INI *pts_mvt,          
			 enum e_sit_typ_not_pos e_sit_typ);
/*/* cumul note pondéré*/
static void cum_not_pon	(		
			 enum  typ_not e_typ_not ,
			 ST_NOT_MVT_INI *pts_mvt
			 );
/* cumul note sans pondéré*/
static void 	cum_not 	(		
			 enum typ_not e_typ_not,
			 ST_NOT_MVT_INI *pts_mvt
			 );
/* Calcul difference pc-ca et min max*/
static void 	cal_dif_max 	(			
			 enum typ_not e_typ_not,
			 ST_NOT_MVT_INI *pts_mvt 
			 );
/* Calcul min max*/
static void 	cal_max 	(		
			 enum typ_not e_typ_not,
			 ST_NOT_MVT_INI *pts_mvt 
			 );
/* recadrage de la note en fonction des mini maxi */
static void 	rec_not_mvt 	(enum typ_not e_typ_not);
/* Recadrage note */
static int 	rec_not		(float min, float max,	 
			       float val);
/* Pondération note */
void 	pon_not		(void);		
 /* Choix coeficient */
static void cho_coe_01 	(void);			       
void cho_coe_02 	(void);			        
static void cho_coe_03 	(void);
static void cho_coe_beg_01(void);
static void cho_coe_int_01(void);
static void cho_coe_hig_01(void);
/* retourne  force du camp */
static void  eva_for_cam(int i_cam, 
			 int *pi_for, 
			 int *pi_nbr_mas_pie,
			 int *pi_nbr_pawn );

static void eva_sit	(void);
static int  ctl_ega	(void); /* return the final choice */


void  	tri_mvt_rec 	(void);		/* tri des mvt initial par ordre decroissant not_rec*/
static void  	tri_mvt_rec_2 	(void);		/* tri des mvt initial par ordre decroissant not_rec*/


unsigned  sel_ran_cho (int u_ran_cho_bas);/* select a random among u_ran_cho_abs */
void  seed_ran_cho (void);                     /* initialisze  the rand function  */
void cho_ver (void);
void cho_ver2 (int i_ver);
/* verifie existance mvt ini */
int ver_exi_mvt_ini(int i_mvt_ini,struct st_evaluation *pst_eva);

void load_not_pos_tbl (int i_pro_act);

